/* Sistemas Integrados TECNISA
   Planejamento Alimentao Industrial

Nome: SUBTHTOD.SQL                                                            

Descrio:                                                                 
Subtrai um determinado nmero de horas e de minutos de uma data e retorna  
a nova data.                                                               

P_DATA  - Data de referncia                                               
P_TEMPO - String contendo o numero de horas e de minutos a serem           
          subtrados da data original.                                     

Criao:
__/__/98 - Tarciso

Manutenes:
12/08/98 - Ederson - inclusao do cabecalho com descrio da funo.

*/
IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
                    WHERE
	        O.NAME = 'SUBTHTOD_PLA'  AND
	        TYPE = 'P' 			        AND
	        U.UID = O.UID             		        AND
	        U.NAME = USER)

  DROP PROCEDURE SUBTHTOD_PLA
  GO

CREATE PROCEDURE SUBTHTOD_PLA @P_DATA DATETIME, @P_TEMPO VARCHAR(2000),
                              @P_DTATUAL DATETIME OUTPUT
AS
   DECLARE @V_HORA   NUMERIC(3);
   DECLARE @V_MINUTO NUMERIC(3);
BEGIN
   IF (NOT @P_TEMPO IS NULL) AND (@P_TEMPO <> '')
   BEGIN
      SET @V_HORA   = CONVERT(NUMERIC,SUBSTRING(@P_TEMPO,1,(DATALENGTH(@P_TEMPO)-2))) * (1/24);
      SET @V_MINUTO = CONVERT(NUMERIC,SUBSTRING(@P_TEMPO,(DATALENGTH(@P_TEMPO)-2)+1,2)) * (1/1440);
      SET @V_HORA   = @V_HORA+@V_MINUTO;
      IF @V_HORA IS NULL
      BEGIN
         SET @V_HORA = 0;
      END;
      SET @P_DTATUAL = @P_DATA - @V_HORA;
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'SUBTHTOD_PLA','4.07.046';
GO

